%define subrel 2

%define use_gitsnap 0
%{?_no_gitsnap: %{expand: %%global use_gitsnap 0}}
%if %{use_gitsnap}
%define gitsnap 200809231700
%endif

# disable the requires on gnome-python-gnomekeyring when it's not avaialable
# gnome-python-desktop requires s-c-p indirectly and the build fails otherwise
%define pygnomekeyring 1

Name:           system-config-printer
Summary:        A printer administration tool
Version:        1.4.3
Release:        %mkrel 1
Url:            http://cyberelk.net/tim/software/system-config-printer/
License:        LGPLv2+
Group:          System/Printing
Source0:        http://cyberelk.net/tim/data/system-config-printer/1.4/%{name}-%{version}%{?gitsnap:-%{gitsnap}}.tar.xz
Source3:        po-mga.tar.bz2
Source4:        mga_printer_custom.py
Source5:        hp-makeuri-mga.c
Source6:        mga_backend
Patch0:         system-config-printer-1.4.2-mga_custom-applet.patch
Patch2:         system-config-printer-1.4.2-mga_custom-system-config-printer.patch
Patch3:         system-config-printer-1.3.1-start-applet.patch
Patch4:         system-config-printer-1.3.12-udev-configure-printer-mga.patch
Patch5:         system-config-printer-1.4.2-mga_custom-embedded_window.patch
# Ubuntu patches
# use hpcups instead of hpijs for HP printers, like in
# previous versions. hpijs is obsolete and hpcup is mature now
Patch101:  50_give-priority-to-hpcups.patch
# when comparing usb uris, deal with the difference between the obsolete
# usblp and the new libusb back-end
Patch102:  67_match-usb-uris-of-usblp-and-libusb.patch
# Fedora patches
Patch200: system-config-printer-no-job-notifications.patch
Patch203: system-config-printer-systemd.patch

# Mageia patches
Patch300:    system-config-printer-1.3.7-remove-Brother-HL-2030-blacklist.patch

BuildRequires:  cups-devel >= 1.2
BuildRequires:  python-devel >= 2.4
BuildRequires:  desktop-file-utils >= 0.2.92
BuildRequires:  gettext-devel
BuildRequires:  intltool
BuildRequires:  xmlto
BuildRequires:  docbook-dtd412-xml
BuildRequires:  docbook-style-xsl
BuildRequires:  udev-devel
BuildRequires:  libusb-devel
BuildRequires:  libhpip-devel
BuildRequires:  dbus-devel
BuildRequires:  dbus-glib-devel
BuildRequires:  systemd-units
Obsoletes:      desktop-printing
Obsoletes:      printerdrake
Provides:       printerdrake
Requires:       python-gi
Requires:       libxml2-python
Requires:       desktop-file-utils >= 0.2.92
Requires:       dbus-x11
Requires:       system-config-printer-libs = %{version}-%{release}
Requires:       system-config-printer-udev = %{version}-%{release}
Requires:       gnome-icon-theme
Requires:       gnome-python
Requires:       virtual-notification-daemon
Requires:       python-dbus
Requires:       python-notify
Requires:       python-curl
Requires:       hplip-model-data
# nmap is required to scan the network, just like 
# printerdrake used to do.
Requires:       nmap
Requires:       python-smbc
Conflicts:      kdeutils4-printer-applet
Suggests:       samba-client
%if %{pygnomekeyring}
Requires:       gnome-python-gnomekeyring
%endif
# (cg) Required for CheckUSBPermissions.py
Requires:       acl

%description
system-config-printer is a graphical user interface that allows
the user to configure a CUPS print server.

%files
%doc ChangeLog README
%{_bindir}/%{name}
%{_bindir}/scp-dbus-service
%{_bindir}/install-printerdriver
%{_sbindir}/%{name}
%{_bindir}/hp-makeuri-mga
%{_bindir}/%{name}-applet
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.py*
%{_datadir}/%{name}/troubleshoot
%{_datadir}/%{name}/ui/*.ui
%{_datadir}/%{name}/xml/*
%{_datadir}/%{name}/icons
%{_datadir}/applications/system-config-printer.desktop
#%{_datadir}/applications/manage-print-jobs.desktop
%{_sysconfdir}/xdg/autostart/print-applet.desktop
%{_mandir}/man1/*

#---------------------------------------------------------------------
%package udev
Summary: Rules for udev for automatic configuration of USB printers
Group:    System/Kernel and hardware
Requires: system-config-printer-libs = %{version}-%{release}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1
Obsoletes: hal-cups-utils <= 0.6.20
Conflicts: cups < 1.4.2-6

%description udev
The udev rules and helper programs for automatically configuring USB
printers.

%post
# disable old printer detection system
if [ -f /etc/sysconfig/printing ]; then
    if grep -q ^AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=.*/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no/g' /etc/sysconfig/printing
    else
        echo AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    fi
    if grep -q ^ENABLE_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/ENABLE_QUEUES_ON_PRINTER_CONNECTED=.*/ENABLE_QUEUES_ON_PRINTER_CONNECTED=no/g' /etc/sysconfig/printing
    else
        echo ENABLE_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    fi
else
    echo AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    echo ENABLE_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
fi

%postun
# enable old printer detection system
if [ -f /etc/sysconfig/printing ]; then
    if grep -q ^AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=.*/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=yes/g' /etc/sysconfig/printing
    fi
    if grep -q ^ENABLE_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/ENABLE_QUEUES_ON_PRINTER_CONNECTED=.*/ENABLE_QUEUES_ON_PRINTER_CONNECTED=yes/g' /etc/sysconfig/printing
    fi
fi

%files udev
%{_prefix}/lib/udev/udev-add-printer
%{_prefix}/lib/udev/udev-configure-printer
%{_udevrulesdir}/70-printers.rules
%{_unitdir}/configure-printer@.service

#---------------------------------------------------------------------

%package  libs
Summary:  Common code for the graphical and non-graphical pieces
Group:    System/Libraries 
Requires: python-gi
Requires: foomatic
Requires: python-cups

%description libs
The common code used by both the graphical and non-graphical parts of
the configuration tool.

%files libs -f system-config-printer.lang
%dir %{_sysconfdir}/cupshelpers/
%config(noreplace) %{_sysconfdir}/cupshelpers/preferreddrivers.xml
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/com.redhat.NewPrinterNotification.conf
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/com.redhat.PrinterDriversInstaller.conf
%config(noreplace) %{_datadir}/dbus-1/interfaces/org.fedoraproject.Config.Printing.xml
%config(noreplace) %{_datadir}/dbus-1/services/org.fedoraproject.Config.Printing.service
%dir %{python_sitelib}/cupshelpers
%{python_sitelib}/cupshelpers/__init__.py*
%{python_sitelib}/cupshelpers/cupshelpers.py*
%{python_sitelib}/cupshelpers/openprinting.py*
%{python_sitelib}/cupshelpers/ppds.py*
%{python_sitelib}/cupshelpers/config.py*
%{python_sitelib}/cupshelpers/installdriver.py*
%{python_sitelib}/cupshelpers/xmldriverprefs.py*
%{_prefix}/lib/cups/backend/mga_backend
%{py_platsitedir}/mga_printer_custom.py*
%{python_sitelib}/*.egg-info

#--------------------------------------------------------------------

%prep
%setup -q 
%patch0 -p1 -b .mga_custom-applet
%patch2 -p1 -b .mga_custom-system-config-printer
%patch3 -p1 -b .start_applet
%patch4 -p1 -b .udev-configue-printer-mga
%patch5 -p1 -b .mga_custom-embedded-window
# %patch101 -p1 -b .hpcupsprio
# %patch102 -p1 -b .libusb
# Don't show job notifications.
%patch200 -p1 -b .no-job-notifications
%patch203 -p1 -b .systemd
%patch300 -p0 -b .mga-1349
# update mga custom translation
tar xvjf %{SOURCE3}
pushd po
for i in *.po; do
    if [ ! -f ../po-mga/$i ]; then
        continue
    fi
    msgcat $i ../po-mga/$i > ../po-mga/$i-new
    rm -f $i
    mv ../po-mga/$i-new $i
done
popd

autoreconf -fi

%build
%if %{use_gitsnap}
./bootstrap
%endif
%configure2_5x \
	--with-systemdsystemunitdir=%{_unitdir} \
	--with-udev-rules

make
# (salem) this hack avoids requiring hplip
gcc %{SOURCE5} -o hp-makeuri-mga -lhpmud

%install
rm -rf %{buildroot}
%makeinstall_std udevrulesdir=%{_prefix}/lib/udev/rules.d  udevhelperdir=%{_prefix}/lib/udev

mkdir -p %{buildroot}%{_mozillaextpath}
mkdir -p %{buildroot}%{py_platsitedir}
mkdir -p %{buildroot}%{_bindir}
cp -f hp-makeuri-mga %{buildroot}%{_bindir}
# Make sure pyc files are generated, otherwise we can get
# difficult to debug problems
pushd %{buildroot}%{_datadir}/%{name}
python -m compileall .
popd
mkdir -p %{buildroot}%{py_platsitedir}
cp -fv %{SOURCE4} %{buildroot}%{py_platsitedir}
pushd %{buildroot}%{py_platsitedir}
python -m compileall .
popd

%{__mkdir_p} %{buildroot}%{_prefix}/lib/cups/backend
cp -f %{SOURCE6} %{buildroot}%{_prefix}/lib/cups/backend

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sbindir}
ln -sf %{_bindir}/%{name} %{buildroot}%{_sbindir}

%find_lang system-config-printer


%changelog
* Thu Mar 27 2014 philippem <philippem> 1.4.3-1.2.mga4
+ Revision: 609019
- fix network printer detection in mga_printer_custom.py (mga#12781)

  + doktor5000 <doktor5000>
    - push fix from philippem to fix network printer detection in mga_backend (mga#12781)
      o (phillipem) better default iface detection in mga_backend, fix nmap parsing

* Thu Dec 19 2013 tv <tv> 1.4.3-1.mga4
+ Revision: 558902
- new release

* Wed Dec 18 2013 tv <tv> 1.4.2-11.mga4
+ Revision: 558640
- install simple-scan rather than xsane

* Wed Dec 18 2013 tv <tv> 1.4.2-10.mga4
+ Revision: 558639
- fix gtk error when adding printer

* Sat Nov 02 2013 fwang <fwang> 1.4.2-9.mga4
+ Revision: 549031
- fix requires

* Mon Oct 28 2013 tv <tv> 1.4.2-8.mga4
+ Revision: 547595
- fix requires now that it uses gobject introspection (mga#11546)

* Sun Oct 27 2013 tv <tv> 1.4.2-7.mga4
+ Revision: 547337
- fix creating Plug with gtk3 (mga#11546)

* Sun Oct 27 2013 tv <tv> 1.4.2-6.mga4
+ Revision: 547332
- use "Gtk" namespace instead of "gtk" (Philippe Makowski, mga#11541)

* Tue Oct 22 2013 umeabot <umeabot> 1.4.2-5.mga4
+ Revision: 544628
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 pterjan <pterjan> 1.4.2-4.mga4
+ Revision: 499900
- Rebuild to add different pythonegg provides for python 2 and 3

* Sun Oct 13 2013 colin <colin> 1.4.2-3.mga4
+ Revision: 496243
- Drop consolehelper stuff. Polkit supoprt should be built in

* Mon Oct 07 2013 neoclust <neoclust> 1.4.2-2.mga4
+ Revision: 492763
+ rebuild (emptylog)

* Mon Oct 07 2013 neoclust <neoclust> 1.4.2-1.mga4
+ Revision: 492758
- New version

* Wed May 15 2013 neoclust <neoclust> 1.3.12-6.mga3
+ Revision: 413265
- Do not fork ( fix printer autodetection ) Special kudos to coling

* Mon Jan 21 2013 malo <malo> 1.3.12-5.mga3
+ Revision: 390315
- updated RPM group

* Thu Jan 17 2013 colin <colin> 1.3.12-4.mga3
+ Revision: 389178
- Remove /var/run files. Code will create it if needed.
- Fix totally broken systemd unit invocation (due to bogus rosa patch)
- Fix udev rules location.

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 20 2012 colin <colin> 1.3.12-2.mga3
+ Revision: 333362
- Strip out systemd variable (it's mandatory these days)
- Require acl needed for some USB Permission checks (mga#8125)

  + dmorgan <dmorgan>
    - Use /usr/lib as we UsrMoved

* Sun Nov 25 2012 luigiwalser <luigiwalser> 1.3.12-1.mga3
+ Revision: 321687
- fix configure-printer service (from rosa)

  + dmorgan <dmorgan>
    - New version 1.3.12

* Sun Aug 19 2012 luigiwalser <luigiwalser> 1.3.11-1.mga3
+ Revision: 282252
- 1.3.11
- re-diff patches 4 and 5
- remove upstreamed patch 201

* Fri Jun 29 2012 colin <colin> 1.3.9-4.mga3
+ Revision: 265034
- Add patch from Fedora to avoid using deprecated udev function
- Rebuild against new libudev major

* Sat Apr 28 2012 tmb <tmb> 1.3.9-3.mga2
+ Revision: 233871
- Require rpm-helper >= 0.24.8-1 for systemd support

* Mon Mar 26 2012 anssi <anssi> 1.3.9-2.mga2
+ Revision: 226535
- fix duplicated lines in udev-add-printer added by
  mga_custom-system-config-printer.patch which caused automatic
  printer configuration to not work properly (part of bug #3616 fix
  (automatic printer installation); the bug was probably a result of an
  erroneus rediff)
- do not install task-printing instead of task-printing-server, which
  was a non-working workaround for the above issue (fixes bug #4811
  (too many unneeded packages installed))
- don't query packagekit for drivers, it would just produce a scary error
  while we have a separate hook to install task-printing-foobar
  (in mga_custom-system-config-printer.patch)
- fix task-printing-foobar hook to use self.remotecupsqueue instead of
  not-yet-populated self.auto_make to trigger package installation
  (part of bug #3616 fix)
- fork udev-configure-printer before trying to install printing server
  as long-running processes should not be run under udev (part of the
  fix for bug #3616, in udev-configure-printer-mga.patch)
- fix cups backend directory on x86_64 (possibly related to bug #3616)

* Mon Mar 05 2012 luigiwalser <luigiwalser> 1.3.9-1.mga2
+ Revision: 218569
- remove upstreamed patches
- 1.3.9

* Fri Feb 24 2012 dmorgan <dmorgan> 1.3.8-2.mga2
+ Revision: 213666
- Add missing python-curl Requires ( mga #4620)

* Sun Feb 19 2012 luigiwalser <luigiwalser> 1.3.8-1.mga2
+ Revision: 211002
- 1.3.8
- add debuginfo patch 202 from Fedora (rh #785581)
- add ppdcache-enoent patch 203 from Fedora (rh #786232)

* Sun Jan 22 2012 dmorgan <dmorgan> 1.3.7-3.mga2
+ Revision: 199539
- Own %%{_sysconfdir}/cupshelpers/

* Fri Jan 13 2012 dmorgan <dmorgan> 1.3.7-2.mga2
+ Revision: 195509
- Disable gutenprint blacklist to test if bug #1349 is fixed
- Change task-printing-server require into task-printing
- New version 1.3.7
- New version 1.3.6
- New version 1.3.5
- Enable systemd at build
- Rediff P4
- Rediff P0
- New version 1.3.4

* Sun Jul 03 2011 dmorgan <dmorgan> 1.3.3-1.mga2
+ Revision: 117530
- New version 1.3.3
  Rediff patch2

* Sat May 14 2011 ennael <ennael> 1.3.1-4.mga1
+ Revision: 98824
- update translations

  + ahmad <ahmad>
    - readd the gnome-python-gnomekeyring bootstrap, as this may be useful when
      porting to new archs (thanks dmorgan)

* Fri Feb 25 2011 ahmad <ahmad> 1.3.1-3.mga1
+ Revision: 59187
- remove the hacky bootstrap, gnome-python-gnomekeyring is available now

* Thu Feb 24 2011 dmorgan <dmorgan> 1.3.1-2.mga1
+ Revision: 59076
- Fix file list
- Add fedora patch ( P200)( Do not show job notifications from the applet (rhbz #677676) )
- Fix udev installation path
- Fix patches name
- Fix custom functions name
- Fix custom functions name
- Rediff and rename system-config-printer-1.3.1-mdv_custom-embedded_window.patch
- Fix applet patch
  Rediff and rename udev patch
- Rediff and rename patch3
- Finish to rediff patch2
- Half rediff patch2 ( the missing part is the rediff of newprinter.py )
- Rediff and rename patch0
- Fix file list
- Remove patch6 not needed anymore
- Update to version 1.3.1

  + ahmad <ahmad>
    - boostrap for gnome-python-gnomekeyring

* Sun Feb 20 2011 ahmad <ahmad> 1.2.0-15.mga1
+ Revision: 54972
- move the python-cups requires to the -libs sub-package (Fedora)
- add requires on gnome-python-gnomekeyring (Fedora)
- drop python-rhpl requires, dropped upstream since 0.7.53

* Sat Feb 19 2011 blino <blino> 1.2.0-14.mga1
+ Revision: 54328
- remove lp ACL workaround, moved in cups
- imported package system-config-printer

